/*
 *--------------------------------------------------------------------
 *
 * TMutex.h
 *
 * A simple encapsulation of Posix mutexes.
 * 
 * Copyright (c) 2001 Kreatel Communications AB. All Rights Reserved
 *
 *--------------------------------------------------------------------
 */

#ifndef TMUTEX_H
#define TMUTEX_H

#include <pthread.h>

class TMutex
{
private:
  pthread_mutex_t Handle;

public:
  TMutex();
  ~TMutex();

  void Lock() throw ();
  void Unlock() throw ();
};

inline TMutex::TMutex()
{
  ::pthread_mutex_init(&Handle, NULL);
}

inline TMutex::~TMutex()
{
  ::pthread_mutex_destroy(&Handle);
}

inline void TMutex::Lock() throw ()
{
  ::pthread_mutex_lock(&Handle);
}

inline void TMutex::Unlock() throw ()
{
  ::pthread_mutex_unlock(&Handle);
}

#endif // TMUTEX_H




